﻿using System;
using System.Xml;
using System.Xml.Serialization;
using System.Windows.Controls;
using System.IO;
using System.Windows;
using System.Windows.Media.Animation;

using SilverlightSocketClient;
using LogicData;

namespace LogicC
{
    public class LogicClient
    {
        //delegate void ScoreDataHandler(ScoreData scoreData);
        //Teams _Teams = null;

        delegate void ChatMsgHandler(ChatData chateData);

        LogicUtil Util = new LogicUtil();

        public void NetworkReceiveMsg(string data)
        {
            StringReader sr = null;
            try
            {
                sr = new StringReader(data);

                if (data.Contains("ChatData"))
                {
                    ChatDataManager chatDataManger = new ChatDataManager(data.ToString());
                    ChatMsgHandler handler = new ChatMsgHandler(UpdateChatMsgData);
                    Page.Instance.Dispatcher.BeginInvoke(handler, new object[] { chatDataManger.chatData });
                }
                else if (data.Contains("LoginSuccessData"))
                {
                    LoginSuccessDataManager loginSuccessDataManger = new LoginSuccessDataManager(data.ToString());
                    Page.Instance.Dispatcher.BeginInvoke(Page.Instance.uiControl.accountUI.LoginSuccess);
                }

                //if (_Teams == null && data.Contains("Teams"))
                //{
                //    XmlSerializer xs = new XmlSerializer(typeof(Teams));
                //    _Teams = (Teams)xs.Deserialize(sr);
                //    Page.Instance.Dispatcher.BeginInvoke(UpdateBoard);
                //}

                ////Get updated score data
                //if (data.Contains("ScoreData"))
                //{
                //    XmlSerializer xs = new XmlSerializer(typeof(ScoreData));
                //    ScoreData scoreData = (ScoreData)xs.Deserialize(sr);
                //    ScoreDataHandler handler = new ScoreDataHandler(UpdateScoreData);
                //    Page.Instance.Dispatcher.BeginInvoke(handler, new object[] { scoreData });
                //}
            }
            catch (Exception e)
            {
            }
            finally
            {
                if (sr != null) sr.Close();
            }
        }

        private void UpdateChatMsgData(ChatData chatData)
        {
            Page.Instance.uiControl.accountUI.ChatListBoxAdd(chatData.ChatMsg, chatData.NickName, chatData.Type);
        }

        public void SendLoginMsg(string id, string pw)
        {
            if (id.Length != 0 && pw.Length != 0)
            {
                LoginDataManager login = new LoginDataManager(id, pw);
                Page.Instance.networkClient.DataSend(login.GetXML().ToString());
            }
        }

        public void SendChatMsg(string chatMsg, string nickName)
        {
            if (chatMsg.Length != 0)
            {
                ChatDataManager chat = new ChatDataManager(chatMsg, nickName, ChatType.NormalChat);
                Page.Instance.networkClient.DataSend(chat.GetXML().ToString());
            }
        }
        public void SendRegisterMsg(string id, string emailAddress)
        {
            if (id.Length != 0 && emailAddress.Length != 0)
            {
                RegisterDataManager register = new RegisterDataManager(id, emailAddress);
                Page.Instance.networkClient.DataSend(register.GetXML().ToString());
            }
        }
        public void SendActiveCodeMsg(string id, string activeCode)
        {
            if (id.Length != 0 && activeCode.Length != 0)
            {
                ActiveCodeDataManager active = new ActiveCodeDataManager(id, activeCode);
                Page.Instance.networkClient.DataSend(active.GetXML().ToString());
            }
        }

        //private void UpdateBoard()
        //{
        //    Page.Instance.tbTeam1Score.Text = "0";
        //    Page.Instance.tbTeam2Score.Text = "0";
        //    Page.Instance.lbActions.Items.Clear();
        //    if (_Teams != null && _Teams.Team != null)
        //    {
        //        for (int i = 0; i < 2; i++)
        //        {
        //            TeamsTeam team = _Teams.Team[i];
        //            if (i == 0)
        //            {
        //                Page.Instance.tbTeam1.Text = team.Name;
        //            }
        //            else
        //            {
        //                Page.Instance.tbTeam2.Text = team.Name;
        //            }
        //        }
        //    }
        //}

        //private void UpdateScoreData(ScoreData scoreData)
        //{
        //    //Update Score
        //    Page.Instance.tbTeam1Score.Text = scoreData.Team1Score.ToString();
        //    Page.Instance.tbTeam2Score.Text = scoreData.Team2Score.ToString();
        //    //Update ball visibility
        //    if (scoreData.Action != ActionsEnum.Foul)
        //    {
        //        if (Page.Instance.tbTeam1.Text == scoreData.TeamOnOffense)
        //        {
        //            AnimateBall(Page.Instance.BB1, Page.Instance.BB2);
        //        }
        //        else //Team 2
        //        {
        //            AnimateBall(Page.Instance.BB2, Page.Instance.BB1);
        //        }
        //    }
        //    if (Page.Instance.lbActions.Items.Count > 11) Page.Instance.lbActions.Items.Clear();
        //    Page.Instance.lbActions.Items.Add(scoreData.LastAction);
        //    if (Page.Instance.lbActions.Visibility == Visibility.Collapsed) Page.Instance.lbActions.Visibility = Visibility.Visible;
        //}

        //private void AnimateBall(Image onBall, Image offBall)
        //{
        //    Page.Instance.FadeIn.Stop();
        //    Storyboard.SetTarget(Page.Instance.FadeInAnimation, onBall);
        //    Storyboard.SetTarget(Page.Instance.FadeOutAnimation, offBall);
        //    Page.Instance.FadeIn.Begin();
        //}
    }
}