﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Timers;
using System.Xml;
using System.Reflection;
using System.Threading;
using System.Xml.Serialization;
using System.Collections;
using System.Data;
using System.Text;

using Network;

namespace GameLogic
{
    class Client : TCPTransfer
    {
        private Thread t;
        private MessageQueue que;
        private event dStringMsg SendToManager;
        public PlayerData playerData = null;

        public Client(Socket s, MessageQueue que, dStringMsg sendToManager)
        {
            this.que = que;
            this.SendToManager += sendToManager;
            t = new Thread(Receive);
            base.HookSocket(s);

            playerData = new PlayerData();
        }

        public void Start()
        {
            t.Start();
        }

        public void Stop()
        {
            t.Abort();
        }

        public override void Send(String d)
        {
            base.Send(d);
        }

        private new void Receive()
        {
            while (base.MySocket.Connected)
            {
                String d = base.Receive();
                que.Enqueue(d);
                SendToManager(MyIP);
            }
        }

        public void SetPlayerData(string id, int loginCount)
        {
            playerData.ID = id;
            playerData.LoginCount = loginCount;
        }

        public string MyIP
        { get { return (IPEndPoint)base.MySocket.RemoteEndPoint + ""; } }

        public class PlayerData
        {
            public string ID { get; set; }
            public int LoginCount  { get; set; }
        }
    }
}