﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Timers;
using System.Xml;
using System.Reflection;
using System.Threading;
using System.Xml.Serialization;
using System.Collections;
using System.Data;
using System.Text;

using GameLogic;

// database manager 클레스 라이브러리
using DataBase;

using LogicData;

namespace Network
{
    class NetworkServer : INetwork
    {
        private TcpListener tcpl;
        private ClientManager manager;
        private Thread t;
        private event dString SendAllMsg;
        private event dStringIP SendGetMsgIP;
        private event dStringSelect SendToAllMsg, SendToOneMsg;

        //Dictionary<string, Dictionary<Guid, string>> _Teams = null;
        //System.Timers.Timer _Timer = null;
        //ScoreData _ScoreData = null;

        public NetworkServer(INetworkServerMsg ui)
        {
            //_Teams = new Dictionary<string, Dictionary<Guid, string>>();

            //Dictionary<Guid, string> _TeamPlayers1 = new Dictionary<Guid, string>();
            //_TeamPlayers1.Add(Guid.NewGuid(), "K. Johnson");
            //_TeamPlayers1.Add(Guid.NewGuid(), "B. Stoudemaire");
            //_TeamPlayers1.Add(Guid.NewGuid(), "O. Neal");
            //_TeamPlayers1.Add(Guid.NewGuid(), "B. Thomas");
            //_TeamPlayers1.Add(Guid.NewGuid(), "T. Baker");

            //Dictionary<Guid, string> _TeamPlayers2 = new Dictionary<Guid, string>();
            //_TeamPlayers2.Add(Guid.NewGuid(), "S. Davidson");
            //_TeamPlayers2.Add(Guid.NewGuid(), "C. Jamison");
            //_TeamPlayers2.Add(Guid.NewGuid(), "M. Bryant");
            //_TeamPlayers2.Add(Guid.NewGuid(), "A. Nash");
            //_TeamPlayers2.Add(Guid.NewGuid(), "J. Doe");

            //_Teams.Add("Bug Slayers", _TeamPlayers1);
            //_Teams.Add("Code Warriors", _TeamPlayers2);

            //_ScoreData = new ScoreData();
            //_ScoreData.TeamOnOffense = "Bug Slayers";

            //_Timer = new System.Timers.Timer();
            //_Timer.Enabled = false;
            //_Timer.Interval = 2000D;
            //_Timer.Elapsed += new ElapsedEventHandler(_Timer_Elapsed);




            tcpl = new TcpListener(IPAddress.Any, ui.Port);
            manager = new ClientManager(GetMsgIP);
            SendAllMsg += new dString(manager.SendToAll);
            SendToAllMsg += new dStringSelect(manager.SendToAll);
            SendToOneMsg += new dStringSelect(manager.SendToOne);

            SendGetMsgIP += new dStringIP(ui.GetMsgIP);
            t = new Thread(Listen);

            IPHostEntry host = Dns.GetHostEntry(Dns.GetHostName());
            string msg = host.AddressList[0] + ":" + ui.Port;
            SendGetMsgIP(msg, ""); // startinfo
        }

        public void Start()
        {
            t.Start();

            // DB에 접속을 한다.
            DataBaseManager.Instance.DBConnect(DataBaseManager.DBType.MSSQL);
        }

        public void Stop()
        {
            t.Abort();
            if (tcpl != null) tcpl.Stop();
            if (manager != null) manager.Close();
        }

        private void Listen()
        {
            try
            {
                tcpl.Start();
                while (true)
                {
                    Socket s = tcpl.AcceptSocket();
                    Client c = manager.Add(s);

                    Console.WriteLine("접속 : " + c.MyIP);
                    Console.WriteLine("현재 접속자 숫자 : " + manager.TotalClientCount());

                    //SendToAll(GetTeamData());
                    //if (_Timer.Enabled == false)
                    //{
                    //    _Timer.Start();
                    //}
                }
            }
            catch (SocketException e)
            {
                SendGetMsgIP(e.Message, "");
                if (tcpl != null) tcpl.Stop();
            }
        }

        //private void _Timer_Elapsed(object sender, ElapsedEventArgs e)
        //{
        //    SendToAll(GetScoreData());
        //    //Setting new interval to simulate different data feed times
        //    Random r = new Random();
        //    _Timer.Interval = (double)r.Next(3000, 7000);
        //}

        public void SendToAll(String d)
        {
            SendAllMsg(d);
        }

        public void SendToAll(String d, Client except)
        {
            SendToAllMsg(d, except);
        }
        public void SendToOne(String d, Client c)
        {
            SendToOneMsg(d, c);
        }

        public void GetMsgIP(String d, string IPFrom)
        {
            SendGetMsgIP(d, IPFrom);
        }

        //private string GetScoreData()
        //{
        //    UpdateScoreData();

        //    StringWriter sw = new StringWriter();
        //    XmlSerializer xm = new XmlSerializer(typeof(ScoreData));
        //    xm.Serialize(sw, _ScoreData);
        //    return sw.ToString();
        //}

        //private void UpdateScoreData()
        //{
        //    Random r = new Random();
        //    //Get last action
        //    ActionsEnum action = (ActionsEnum)r.Next(0, Enum.GetNames(typeof(ActionsEnum)).Length);
        //    //Get player that performed action
        //    KeyValuePair<Guid, string> player = GetActionPlayer(action);
        //    string defensiveTeam = _Teams.Keys.Where(key => key != _ScoreData.TeamOnOffense).First();
        //    string message = _ScoreData.TeamOnOffense + ": " + player.Value;
        //    switch (action)
        //    {
        //        case ActionsEnum.Foul:
        //            message = defensiveTeam + ": " + player.Value + " committed a foul.";
        //            break;
        //        case ActionsEnum.Made2Pointer:
        //            message += " scored 2 points.";
        //            break;
        //        case ActionsEnum.Made3Pointer:
        //            message += " scored 3 points.";
        //            break;
        //        case ActionsEnum.MadeFoulShot:
        //            message += " made a foul shot after foul.";
        //            break;
        //        case ActionsEnum.Miss:
        //            message += " missed.";
        //            break;
        //        case ActionsEnum.Turnover:
        //            message += " turned it over";
        //            break;
        //    }


        //    int teamPos = 1;
        //    int points = ((int)action > 3) ? 0 : (int)action;
        //    foreach (string name in _Teams.Keys)
        //    {
        //        if (teamPos == 1 && name == _ScoreData.TeamOnOffense)
        //        {
        //            _ScoreData.Team1Score += points;
        //        }
        //        if (teamPos == 2 && name == _ScoreData.TeamOnOffense)
        //        {
        //            _ScoreData.Team2Score += points;
        //        }
        //        teamPos++;
        //    }

        //    _ScoreData.Action = action;
        //    _ScoreData.LastActionPlayerID = player.Key;
        //    _ScoreData.LastAction = message;
        //    _ScoreData.LastActionPoints = points;

        //    //Change teams if a foul wasn't committed
        //    if (action != ActionsEnum.Foul)
        //    {
        //        _ScoreData.TeamOnOffense = defensiveTeam;
        //    }
        //}

        //private KeyValuePair<Guid, string> GetActionPlayer(ActionsEnum action)
        //{
        //    Dictionary<Guid, string> players = null;
        //    if (action == ActionsEnum.Foul)
        //    {
        //        //Get defensive team players
        //        players = _Teams[_Teams.Keys.Where(name => name != _ScoreData.TeamOnOffense).First()];
        //    }
        //    else
        //    {
        //        players = _Teams[_Teams.Keys.Where(name => name == _ScoreData.TeamOnOffense).First()];
        //    }

        //    Random r = new Random();
        //    return players.ElementAt(r.Next(0, players.Count));
        //}


        //private string GetTeamData()
        //{
        //    StringWriter sw = new StringWriter();
        //    using (XmlWriter writer = XmlWriter.Create(sw))
        //    {
        //        writer.WriteStartElement("Teams");
        //        foreach (string key in _Teams.Keys)
        //        {
        //            writer.WriteStartElement("Team");
        //            writer.WriteAttributeString("Name", key);
        //            Dictionary<Guid, string> players = _Teams[key];
        //            foreach (Guid playerKey in players.Keys)
        //            {
        //                writer.WriteStartElement("Player");
        //                writer.WriteAttributeString("ID", playerKey.ToString());
        //                writer.WriteAttributeString("Name", players[playerKey]);
        //                writer.WriteEndElement();
        //            }
        //            writer.WriteEndElement();
        //        }
        //        writer.WriteEndElement();
        //    }
        //    return sw.ToString();
        //}
    }

    class ClientManager
    {
        private MessageQueue que;
        private event dStringIP SendToServerIP;

        public ClientManager(dStringIP sendToServerIP)
        {
            que = new MessageQueue();
            this.SendToServerIP = sendToServerIP;
        }

        public Client Add(Socket s)
        {
            Client c = new Client(s, que, Send);
            LogicManager.Instance.ClientList.Add(c.MyIP, c);
            c.Start();
            return c;
        }

        public int TotalClientCount()
        {
            return LogicManager.Instance.ClientList.Count;
        }

        public void Close()
        {
            SendToAll("서버가 종료되었습니다");
            foreach (Client c in LogicManager.Instance.ClientList.Values)
            c.Stop();
            LogicManager.Instance.ClientList.Clear();
        }

        public void SendToAll(String d)
        {
            foreach (Client c in LogicManager.Instance.ClientList.Values)
                c.Send(d);
        }

        public void SendToAll(String d, Client except)
        {
            foreach (Client c in LogicManager.Instance.ClientList.Values)
                if (c != except) c.Send(d);
        }

        public void SendToOne(String d, Client c)
        {
            c.Send(d);
        }

        private void Send(string IPFrom)
        {
            String d = que.Dequeue();

            //switch (d.code)
            //{
            //    case NetworkMsgCode.LogIn:
            //        list[IPFrom].Send(new String(NetworkMsgCode.StartInfo, "로그인"));
            //        SendToAll(d);
            //        break;

            //    case NetworkMsgCode.LogOut:
            //        Client c = list[IPFrom];
            //        list.Remove(IPFrom);
            //        SendToServer(d);
            //        SendToAll(d);
            //        c.Stop();
            //        break;

            //    //case ChatCode.Msg:
            //    //    SendToAll(d, list[IPFrom]);
            //    //    break;

            //    //case ChatCode.Whisper:
            //    //    SendToOne(d, list[nlist[d.msgTo]]);
            //    //    break;

            //    //case ChatCode.Nick:
            //    //    break;

            //    //case ChatCode.File:
            //    //    break;
            //}

            SendToServerIP(d, IPFrom);
        }
    }
}
